<?php

namespace SGalinski\SgNews\Hooks;

/***************************************************************
 *  Copyright notice
 *
 *  (c) sgalinski Internet Services (https://www.sgalinski.de)
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

use SGalinski\SgNews\Utility\BackendNewsUtility;
use TYPO3\CMS\Backend\Controller\EditDocumentController as CoreEditDocumentController;
use TYPO3\CMS\Backend\Utility\BackendUtility;

/**
 * Backend edid form hook
 */
class EditDocumentController {

	/**
	 * Sets the default value for the pages author field
	 * to the name of the logged-in user
	 *
	 * @param CoreEditDocumentController $controller
	 * @return void
	 */
	public function preInitAfter($controller) {
		$tables = ['pages'];
		if (
			$GLOBALS['BE_USER']->user['realName'] !== ''
			&& (isset($controller->editconf[$tables[0]]) || isset($controller->editconf[$tables[1]]))
		) {
			$doktype = 0;
			$userName = $GLOBALS['BE_USER']->user['realName'];
			$tableName = isset($controller->editconf[$tables[0]]) ? $tables[0] : $tables[1];
			$command = reset($controller->editconf[$tableName]);
			$pageUid = key($controller->editconf[$tableName]);
			if ($command === 'edit') {
				$pageRow = BackendUtility::getRecord($tableName, (int) $pageUid);
				if ($pageRow && isset($pageRow['doktype'])) {
					$doktype = (int) $pageRow['doktype'];
				}
			} elseif ($command === 'new' && isset($controller->overrideVals[$tableName]['doktype'])) {
				$doktype = (int) $controller->overrideVals[$tableName]['doktype'];
			}
			if ($doktype === BackendNewsUtility::NEWS_DOKTYPE) {
				$GLOBALS['BE_USER']->userTS['TCAdefaults.'][$tableName . '.']['author'] = $userName;
			}
		}
	}
}
